Index: LMDZ5/branches/testing/libf/misc/xersve.F
===================================================================
--- LMDZ5/branches/testing/libf/misc/xersve.F	(revision 2298)
+++ LMDZ5/branches/testing/libf/misc/xersve.F	(revision 2298)
@@ -0,0 +1,159 @@
+*DECK XERSVE
+      SUBROUTINE XERSVE (LIBRAR, SUBROU, MESSG, KFLAG, NERR, LEVEL,
+     +   ICOUNT)
+      IMPLICIT NONE
+C***BEGIN PROLOGUE  XERSVE
+C***SUBSIDIARY
+C***PURPOSE  Record that an error has occurred.
+C***LIBRARY   SLATEC (XERROR)
+C***CATEGORY  R3
+C***TYPE      ALL (XERSVE-A)
+C***KEYWORDS  ERROR, XERROR
+C***AUTHOR  Jones, R. E., (SNLA)
+C***DESCRIPTION
+C
+C *Usage:
+C
+C        INTEGER  KFLAG, NERR, LEVEL, ICOUNT
+C        CHARACTER * (len) LIBRAR, SUBROU, MESSG
+C
+C        CALL XERSVE (LIBRAR, SUBROU, MESSG, KFLAG, NERR, LEVEL, ICOUNT)
+C
+C *Arguments:
+C
+C        LIBRAR :IN    is the library that the message is from.
+C        SUBROU :IN    is the subroutine that the message is from.
+C        MESSG  :IN    is the message to be saved.
+C        KFLAG  :IN    indicates the action to be performed.
+C                      when KFLAG > 0, the message in MESSG is saved.
+C                      when KFLAG=0 the tables will be dumped and
+C                      cleared.
+C                      when KFLAG < 0, the tables will be dumped and
+C                      not cleared.
+C        NERR   :IN    is the error number.
+C        LEVEL  :IN    is the error severity.
+C        ICOUNT :OUT   the number of times this message has been seen,
+C                      or zero if the table has overflowed and does not
+C                      contain this message specifically.  When KFLAG=0,
+C                      ICOUNT will not be altered.
+C
+C *Description:
+C
+C   Record that this error occurred and possibly dump and clear the
+C   tables.
+C
+C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
+C                 Error-handling Package, SAND82-0800, Sandia
+C                 Laboratories, 1982.
+C***ROUTINES CALLED  I1MACH, XGETUA
+C***REVISION HISTORY  (YYMMDD)
+C   800319  DATE WRITTEN
+C   861211  REVISION DATE from Version 3.2
+C   891214  Prologue converted to Version 4.0 format.  (BAB)
+C   900413  Routine modified to remove reference to KFLAG.  (WRB)
+C   900510  Changed to add LIBRARY NAME and SUBROUTINE to calling
+C           sequence, use IF-THEN-ELSE, make number of saved entries
+C           easily changeable, changed routine name from XERSAV to
+C           XERSVE.  (RWC)
+C   910626  Added LIBTAB and SUBTAB to SAVE statement.  (BKS)
+C   920501  Reformatted the REFERENCES section.  (WRB)
+C***END PROLOGUE  XERSVE
+      INTEGER,PARAMETER :: LENTAB=10
+      INTEGER LUN(5)
+      CHARACTER*(*) LIBRAR, SUBROU, MESSG
+      CHARACTER*8  LIBTAB(LENTAB), SUBTAB(LENTAB), LIB, SUB
+      CHARACTER*20 MESTAB(LENTAB), MES
+      DIMENSION NERTAB(LENTAB), LEVTAB(LENTAB), KOUNT(LENTAB)
+      SAVE LIBTAB, SUBTAB, MESTAB, NERTAB, LEVTAB, KOUNT, KOUNTX, NMSG
+      DATA KOUNTX/0/, NMSG/0/
+      INTEGER NERR,LEVEL,KONTRL
+      INTEGER NERTAB, LEVTAB, KOUNT, KOUNTX, NMSG
+      INTEGER KFLAG, ICOUNT, NUNIT, KUNIT, IUNIT, I1MACH, I
+C***FIRST EXECUTABLE STATEMENT  XERSVE
+C
+      IF (KFLAG.LE.0) THEN
+C
+C        Dump the table.
+C
+         IF (NMSG.EQ.0) RETURN
+C
+C        Print to each unit.
+C
+         CALL XGETUA (LUN, NUNIT)
+         DO 20 KUNIT = 1,NUNIT
+            IUNIT = LUN(KUNIT)
+            IF (IUNIT.EQ.0) IUNIT = I1MACH(4)
+C
+C           Print the table header.
+C
+            WRITE (IUNIT,9000)
+C
+C           Print body of table.
+C
+            DO 10 I = 1,NMSG
+               WRITE (IUNIT,9010) LIBTAB(I), SUBTAB(I), MESTAB(I),
+     *            NERTAB(I),LEVTAB(I),KOUNT(I)
+   10       CONTINUE
+C
+C           Print number of other errors.
+C
+            IF (KOUNTX.NE.0) WRITE (IUNIT,9020) KOUNTX
+            WRITE (IUNIT,9030)
+   20    CONTINUE
+C
+C        Clear the error tables.
+C
+         IF (KFLAG.EQ.0) THEN
+            NMSG = 0
+            KOUNTX = 0
+         ENDIF
+      ELSE
+C
+C        PROCESS A MESSAGE...
+C        SEARCH FOR THIS MESSG, OR ELSE AN EMPTY SLOT FOR THIS MESSG,
+C        OR ELSE DETERMINE THAT THE ERROR TABLE IS FULL.
+C
+         LIB = LIBRAR
+         SUB = SUBROU
+         MES = MESSG
+         DO 30 I = 1,NMSG
+            IF (LIB.EQ.LIBTAB(I) .AND. SUB.EQ.SUBTAB(I) .AND.
+     *         MES.EQ.MESTAB(I) .AND. NERR.EQ.NERTAB(I) .AND.
+     *         LEVEL.EQ.LEVTAB(I)) THEN
+                  KOUNT(I) = KOUNT(I) + 1
+                  ICOUNT = KOUNT(I)
+                  RETURN
+            ENDIF
+   30    CONTINUE
+C
+         IF (NMSG.LT.LENTAB) THEN
+C
+C           Empty slot found for new message.
+C
+            NMSG = NMSG + 1
+            LIBTAB(I) = LIB
+            SUBTAB(I) = SUB
+            MESTAB(I) = MES
+            NERTAB(I) = NERR
+            LEVTAB(I) = LEVEL
+            KOUNT (I) = 1
+            ICOUNT    = 1
+         ELSE
+C
+C           Table is full.
+C
+            KOUNTX = KOUNTX+1
+            ICOUNT = 0
+         ENDIF
+      ENDIF
+      RETURN
+C
+C     Formats.
+C
+ 9000 FORMAT ('0          ERROR MESSAGE SUMMARY' /
+     +   ' LIBRARY    SUBROUTINE MESSAGE START             NERR',
+     +   '     LEVEL     COUNT')
+ 9010 FORMAT (1X,A,3X,A,3X,A,3I10)
+ 9020 FORMAT ('0OTHER ERRORS NOT INDIVIDUALLY TABULATED = ', I10)
+ 9030 FORMAT (1X)
+      END
Index: LMDZ5/branches/testing/libf/misc/xgetua.F
===================================================================
--- LMDZ5/branches/testing/libf/misc/xgetua.F	(revision 2298)
+++ LMDZ5/branches/testing/libf/misc/xgetua.F	(revision 2298)
@@ -0,0 +1,53 @@
+*DECK XGETUA
+      SUBROUTINE XGETUA (IUNITA, N)
+      IMPLICIT NONE
+C***BEGIN PROLOGUE  XGETUA
+C***PURPOSE  Return unit number(s) to which error messages are being
+C            sent.
+C***LIBRARY   SLATEC (XERROR)
+C***CATEGORY  R3C
+C***TYPE      ALL (XGETUA-A)
+C***KEYWORDS  ERROR, XERROR
+C***AUTHOR  Jones, R. E., (SNLA)
+C***DESCRIPTION
+C
+C     Abstract
+C        XGETUA may be called to determine the unit number or numbers
+C        to which error messages are being sent.
+C        These unit numbers may have been set by a call to XSETUN,
+C        or a call to XSETUA, or may be a default value.
+C
+C     Description of Parameters
+C      --Output--
+C        IUNIT - an array of one to five unit numbers, depending
+C                on the value of N.  A value of zero refers to the
+C                default unit, as defined by the I1MACH machine
+C                constant routine.  Only IUNIT(1),...,IUNIT(N) are
+C                defined by XGETUA.  The values of IUNIT(N+1),...,
+C                IUNIT(5) are not defined (for N .LT. 5) or altered
+C                in any way by XGETUA.
+C        N     - the number of units to which copies of the
+C                error messages are being sent.  N will be in the
+C                range from 1 to 5.
+C
+C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
+C                 Error-handling Package, SAND82-0800, Sandia
+C                 Laboratories, 1982.
+C***ROUTINES CALLED  J4SAVE
+C***REVISION HISTORY  (YYMMDD)
+C   790801  DATE WRITTEN
+C   861211  REVISION DATE from Version 3.2
+C   891214  Prologue converted to Version 4.0 format.  (BAB)
+C   920501  Reformatted the REFERENCES section.  (WRB)
+C***END PROLOGUE  XGETUA
+      DIMENSION IUNITA(5)
+      INTEGER IUNITA, N, J4SAVE, INDEX, I
+C***FIRST EXECUTABLE STATEMENT  XGETUA
+      N = J4SAVE(5,0,.FALSE.)
+      DO 30 I=1,N
+         INDEX = I+4
+         IF (I.EQ.1) INDEX = 3
+         IUNITA(I) = J4SAVE(INDEX,0,.FALSE.)
+   30 CONTINUE
+      RETURN
+      END
Index: LMDZ5/branches/testing/libf/phylmd/calcul_STDlev.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calcul_STDlev.h	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/calcul_STDlev.h	(revision 2298)
@@ -4,5 +4,5 @@
 !IM on initialise les variables 
 !
-        missing_val=nf90_fill_real
+!       missing_val=nf90_fill_real
 !
         CALL ini_undefSTD(itap,itapm1)
Index: LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90	(revision 2298)
@@ -5,12 +5,14 @@
 CONTAINS
   SUBROUTINE calcul_fluxs( knon, nisurf, dtime, &
-       tsurf, p1lay, cal, beta, coef1lay, ps, &
+       tsurf, p1lay, cal, beta, cdragh, cdragq, ps, &
        precip_rain, precip_snow, snow, qsurf, &
-       radsol, dif_grnd, t1lay, q1lay, u1lay, v1lay, &
-       petAcoef, peqAcoef, petBcoef, peqBcoef, &
+       radsol, dif_grnd, t1lay, q1lay, u1lay, v1lay, gustiness, &
+       fqsat, petAcoef, peqAcoef, petBcoef, peqBcoef, &
        tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
     
     USE dimphy, ONLY : klon
     USE indice_sol_mod
+
+    INCLUDE "clesphys.h"
 
 ! Cette routine calcule les fluxs en h et q a l'interface et eventuellement
@@ -26,5 +28,6 @@
 !   cal          capacite calorifique du sol
 !   beta         evap reelle
-!   coef1lay     coefficient d'echange
+!   cdragh       coefficient d'echange temperature
+!   cdragq       coefficient d'echange evaporation
 !   ps           pression au sol
 !   precip_rain  precipitations liquides
@@ -59,8 +62,9 @@
     REAL, DIMENSION(klon), INTENT(IN)    :: petBcoef, peqBcoef
     REAL, DIMENSION(klon), INTENT(IN)    :: ps, q1lay
-    REAL, DIMENSION(klon), INTENT(IN)    :: tsurf, p1lay, cal, beta, coef1lay
+    REAL, DIMENSION(klon), INTENT(IN)    :: tsurf, p1lay, cal, beta, cdragh,cdragq
     REAL, DIMENSION(klon), INTENT(IN)    :: precip_rain, precip_snow ! pas utiles
     REAL, DIMENSION(klon), INTENT(IN)    :: radsol, dif_grnd
-    REAL, DIMENSION(klon), INTENT(IN)    :: t1lay, u1lay, v1lay
+    REAL, DIMENSION(klon), INTENT(IN)    :: t1lay, u1lay, v1lay,gustiness
+    REAL,                  INTENT(IN)    :: fqsat ! correction factor on qsat (generally 0.98 over salty water, 1 everywhere else)
 
 ! Parametres entree-sorties
@@ -79,6 +83,6 @@
     REAL, DIMENSION(klon)                :: zx_mh, zx_nh, zx_oh
     REAL, DIMENSION(klon)                :: zx_mq, zx_nq, zx_oq
-    REAL, DIMENSION(klon)                :: zx_pkh, zx_dq_s_dt, zx_qsat, zx_coef
-    REAL, DIMENSION(klon)                :: zx_sl, zx_k1
+    REAL, DIMENSION(klon)                :: zx_pkh, zx_dq_s_dt, zx_qsat
+    REAL, DIMENSION(klon)                :: zx_sl, zx_coefh, zx_coefq, zx_wind
     REAL, DIMENSION(klon)                :: d_ts
     REAL                                 :: zdelta, zcvm5, zx_qs, zcor, zx_dq_s_dh
@@ -125,5 +129,5 @@
     fluxlat=0.
     dflux_s = 0.
-    dflux_l = 0.	
+    dflux_l = 0.
 !
 ! zx_qs = qsat en kg/kg
@@ -154,8 +158,11 @@
        zx_dq_s_dt(i) = RCPD * zx_pkh(i) * zx_dq_s_dh
        zx_qsat(i) = zx_qs
-       zx_coef(i) = coef1lay(i) * &
-            (1.0+SQRT(u1lay(i)**2+v1lay(i)**2)) * &
-            p1lay(i)/(RD*t1lay(i))
-       
+       zx_wind(i)=min_wind_speed+SQRT(gustiness(i)+u1lay(i)**2+v1lay(i)**2)
+       zx_coefh(i) = cdragh(i) * zx_wind(i) * p1lay(i)/(RD*t1lay(i))
+       zx_coefq(i) = cdragq(i) * zx_wind(i) * p1lay(i)/(RD*t1lay(i))
+!      zx_wind(i)=min_wind_speed+SQRT(gustiness(i)+u1lay(i)**2+v1lay(i)**2) &
+!                * p1lay(i)/(RD*t1lay(i))
+!      zx_coefh(i) = cdragh(i) * zx_wind(i)
+!      zx_coefq(i) = cdragq(i) * zx_wind(i)
     ENDDO
 
@@ -168,5 +175,4 @@
        zx_sl(i) = RLVTT
        IF (tsurf(i) .LT. RTT) zx_sl(i) = RLSTT
-       zx_k1(i) = zx_coef(i)
     ENDDO
     
@@ -174,16 +180,18 @@
     DO i = 1, knon
 ! Q
-       zx_oq(i) = 1. - (beta(i) * zx_k1(i) * peqBcoef(i) * dtime)
-       zx_mq(i) = beta(i) * zx_k1(i) * &
-            (peqAcoef(i) - zx_qsat(i) + &
-            zx_dq_s_dt(i) * tsurf(i)) &
+       zx_oq(i) = 1. - (beta(i) * zx_coefq(i) * peqBcoef(i) * dtime)
+       zx_mq(i) = beta(i) * zx_coefq(i) * &
+            (peqAcoef(i) -             &
+! conv num avec precedente version
+            fqsat * zx_qsat(i) + fqsat * zx_dq_s_dt(i) * tsurf(i))  &
+!           fqsat * ( zx_qsat(i) - zx_dq_s_dt(i) * tsurf(i)) ) &
             / zx_oq(i)
-       zx_nq(i) = beta(i) * zx_k1(i) * (-1. * zx_dq_s_dt(i)) &
+       zx_nq(i) = beta(i) * zx_coefq(i) * (- fqsat * zx_dq_s_dt(i)) &
             / zx_oq(i)
        
 ! H
-       zx_oh(i) = 1. - (zx_k1(i) * petBcoef(i) * dtime)
-       zx_mh(i) = zx_k1(i) * petAcoef(i) / zx_oh(i)
-       zx_nh(i) = - (zx_k1(i) * RCPD * zx_pkh(i))/ zx_oh(i)
+       zx_oh(i) = 1. - (zx_coefh(i) * petBcoef(i) * dtime)
+       zx_mh(i) = zx_coefh(i) * petAcoef(i) / zx_oh(i)
+       zx_nh(i) = - (zx_coefh(i) * RCPD * zx_pkh(i))/ zx_oh(i)
      
 ! Tsurface
@@ -244,5 +252,5 @@
 !
   SUBROUTINE calcul_flux_wind(knon, dtime, &
-       u0, v0, u1, v1, cdrag_m, &
+       u0, v0, u1, v1, gustiness, cdrag_m, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
        p1lay, t1lay, &
@@ -251,4 +259,5 @@
     USE dimphy
     INCLUDE "YOMCST.h"
+    INCLUDE "clesphys.h"
 
 ! Input arguments
@@ -257,5 +266,5 @@
     REAL, INTENT(IN)                     :: dtime
     REAL, DIMENSION(klon), INTENT(IN)    :: u0, v0  ! u and v at niveau 0
-    REAL, DIMENSION(klon), INTENT(IN)    :: u1, v1  ! u and v at niveau 1
+    REAL, DIMENSION(klon), INTENT(IN)    :: u1, v1, gustiness  ! u and v at niveau 1
     REAL, DIMENSION(klon), INTENT(IN)    :: cdrag_m ! cdrag pour momentum
     REAL, DIMENSION(klon), INTENT(IN)    :: AcoefU, AcoefV, BcoefU, BcoefV
@@ -277,5 +286,5 @@
 !****************************************************************************************
     DO i=1,knon
-       mod_wind = 1.0 + SQRT((u1(i) - u0(i))**2 + (v1(i)-v0(i))**2)
+       mod_wind = min_wind_speed + SQRT(gustiness(i)+(u1(i) - u0(i))**2 + (v1(i)-v0(i))**2)
        buf = cdrag_m(i) * mod_wind * p1lay(i)/(RD*t1lay(i))
        flux_u1(i) = (AcoefU(i) - u0(i)) / (1/buf - BcoefU(i)*dtime )
Index: LMDZ5/branches/testing/libf/phylmd/carbon_cycle_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/carbon_cycle_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/carbon_cycle_mod.F90	(revision 2298)
@@ -157,5 +157,6 @@
     itc=0
     DO it=1,nbtr
-       iiq=niadv(it+2)
+!!       iiq=niadv(it+2)                                                            ! jyg
+       iiq=niadv(it+nqo)                                                            ! jyg
        
        SELECT CASE(tname(iiq))
Index: LMDZ5/branches/testing/libf/phylmd/cdrag.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cdrag.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cdrag.F90	(revision 2298)
@@ -4,5 +4,5 @@
  SUBROUTINE cdrag( knon,  nsrf,   &
      speed, t1,    q1,    zgeop1, &
-     psol,  tsurf, qsurf, rugos,  &
+     psol,  tsurf, qsurf, z0m, z0h,  &
      pcfm,  pcfh,  zri,   pref )
 
@@ -45,5 +45,5 @@
 ! tsurf---input-R- temperature de l'air a la surface 
 ! qsurf---input-R- humidite de l'air a la surface
-! rugos---input-R- rugosite
+! z0m, z0h---input-R- rugosite
 !! u1, v1 are removed, speed is used. Fuxing WANG, 04/03/2015,
 !! u1------input-R- vent zonal au 1er niveau du modele
@@ -71,5 +71,5 @@
   REAL, DIMENSION(klon), INTENT(IN)        :: tsurf ! Surface temperature (K)
   REAL, DIMENSION(klon), INTENT(IN)        :: qsurf ! Surface humidity (Kg/Kg)
-  REAL, DIMENSION(klon), INTENT(IN)        :: rugos ! Rugosity at surface (m) 
+  REAL, DIMENSION(klon), INTENT(IN)        :: z0m, z0h ! Rugosity at surface (m) 
 !  paprs, pplay u1, v1: to be deleted
 !  they were in the old clcdrag. Fuxing WANG, 04/03/2015
@@ -113,5 +113,5 @@
   REAL, DIMENSION(klon) :: zcfh1, zcfh2 ! Drag coefficient for heat flux
   LOGICAL, PARAMETER    :: zxli=.FALSE. ! calcul des cdrags selon Laurent Li
-  REAL, DIMENSION(klon) :: zcdn         ! Drag coefficient in neutral conditions
+  REAL, DIMENSION(klon) :: zcdn_m, zcdn_h         ! Drag coefficient in neutral conditions
 !
 ! Fonctions thermodynamiques et fonctions d'instabilite
@@ -174,5 +174,9 @@
           *(1.+RETV*max(q1(i),0.0)) ! negative q1 set to zero
      zri(i) = zgeop1(i)*(ztvd-ztsolv)/(zdu2*ztvd)
-     zcdn(i) = (CKAP/LOG(1.+zgeop1(i)/(RG*rugos(i))))**2
+
+
+! Coefficients CD neutres pour m et h
+     zcdn_m(i) = (CKAP/LOG(1.+zgeop1(i)/(RG*z0m(i))))**2
+     zcdn_h(i) = (CKAP/LOG(1.+zgeop1(i)/(RG*z0h(i))))**2
 
      IF (zri(i) .GT. 0.) THEN      ! situation stable
@@ -181,33 +185,35 @@
            zscf = SQRT(1.+CD*ABS(zri(i)))
            friv = AMAX1(1. / (1.+2.*CB*zri(i)/ZSCF), f_ri_cd_min)
-           zcfm1(i) = zcdn(i) * friv
+           zcfm1(i) = zcdn_m(i) * friv
            frih = AMAX1(1./ (1.+3.*CB*zri(i)*ZSCF), f_ri_cd_min )
 !!$ PB     zcfh1(i) = zcdn(i) * frih
 !!$ PB     zcfh1(i) = f_cdrag_stable * zcdn(i) * frih
-           zcfh1(i) = f_cdrag_ter * zcdn(i) * frih
-           IF(nsrf.EQ.is_oce) zcfh1(i) = f_cdrag_oce * zcdn(i) * frih
+           zcfh1(i) = f_cdrag_ter * zcdn_h(i) * frih
+           IF(nsrf.EQ.is_oce) zcfh1(i) = f_cdrag_oce * zcdn_h(i) * frih
 !!$ PB
            pcfm(i) = zcfm1(i)
            pcfh(i) = zcfh1(i)
         ELSE
-           pcfm(i) = zcdn(i)* fsta(zri(i))
-           pcfh(i) = zcdn(i)* fsta(zri(i))
+           pcfm(i) = zcdn_m(i)* fsta(zri(i))
+           pcfh(i) = zcdn_h(i)* fsta(zri(i))
         ENDIF
      ELSE                          ! situation instable
         IF (.NOT.zxli) THEN
-           zucf = 1./(1.+3.0*CB*CC*zcdn(i)*SQRT(ABS(zri(i)) &
-                *(1.0+zgeop1(i)/(RG*rugos(i)))))
-           zcfm2(i) = zcdn(i)*amax1((1.-2.0*CB*zri(i)*zucf),f_ri_cd_min)
-!!$ PB     zcfh2(i) = zcdn(i)*amax1((1.-3.0*cb*zri(i)*zucf),f_ri_cd_min)
-           zcfh2(i) = f_cdrag_ter*zcdn(i)*amax1((1.-3.0*CB*zri(i)*zucf),f_ri_cd_min)
+           zucf = 1./(1.+3.0*CB*CC*zcdn_m(i)*SQRT(ABS(zri(i)) &
+                *(1.0+zgeop1(i)/(RG*z0m(i)))))
+           zcfm2(i) = zcdn_m(i)*amax1((1.-2.0*CB*zri(i)*zucf),f_ri_cd_min)
+!!$ PB     zcfh2(i) = zcdn_h(i)*amax1((1.-3.0*cb*zri(i)*zucf),f_ri_cd_min)
+           zcfh2(i) = f_cdrag_ter*zcdn_h(i)*amax1((1.-3.0*CB*zri(i)*zucf),f_ri_cd_min)
            pcfm(i) = zcfm2(i)
            pcfh(i) = zcfh2(i)
         ELSE
-           pcfm(i) = zcdn(i)* fins(zri(i))
-           pcfh(i) = zcdn(i)* fins(zri(i))
+           pcfm(i) = zcdn_m(i)* fins(zri(i))
+           pcfh(i) = zcdn_h(i)* fins(zri(i))
         ENDIF
-! cdrah sur l'ocean cf. Miller et al. (1992)
-        zcr = (0.0016/(zcdn(i)*SQRT(zdu2)))*ABS(ztvd-ztsolv)**(1./3.)
-        IF(nsrf.EQ.is_oce) pcfh(i) =f_cdrag_oce* zcdn(i)*(1.0+zcr**1.25)**(1./1.25)
+        IF(iflag_gusts==0) THEN
+! cdrah sur l'ocean cf. Miller et al. (1992) - only active when gustiness parameterization is not active
+           zcr = (0.0016/(zcdn_m(i)*SQRT(zdu2)))*ABS(ztvd-ztsolv)**(1./3.)
+           IF(nsrf.EQ.is_oce) pcfh(i) =f_cdrag_oce* zcdn_h(i)*(1.0+zcr**1.25)**(1./1.25)
+        ENDIF
      ENDIF
   END DO
Index: LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90	(revision 2298)
@@ -12,8 +12,6 @@
 
   SUBROUTINE change_srf_frac(itime, dtime, jour, &
-!albedo SB >>>
-!       pctsrf, alb1, alb2, tsurf, ustar, u10m, v10m, pbl_tke)
-        pctsrf, alb_dir, alb_dif, tsurf, ustar, u10m, v10m, pbl_tke)
-!albedo SB <<<
+        pctsrf, evap, z0m, z0h, agesno,              &
+        alb_dir, alb_dif, tsurf, ustar, u10m, v10m, pbl_tke)
    
 
@@ -54,7 +52,7 @@
    
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: pctsrf ! sub-surface fraction
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: evap, agesno ! sub-surface fraction
+    REAL, DIMENSION(klon,nbsrf+1), INTENT(INOUT) :: z0m,z0h ! sub-surface fraction
 !albedo SB >>>
-!   REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb1   ! albedo first interval in SW spektrum
-!   REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: alb2   ! albedo second interval in SW spektrum
     REAL, DIMENSION(klon,nsw,nbsrf), INTENT(INOUT) :: alb_dir,alb_dif
 !albedo SB <<<
@@ -176,10 +174,7 @@
 !****************************************************************************************
 
-!albedo SB >>>
-! CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old, tsurf, alb1, alb2, ustar,
-! u10m, v10m, pbl_tke)
-       CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old, tsurf, alb_dir,alb_dif, ustar, u10m, v10m, pbl_tke)
-!albedo SB <<<
-
+       CALL pbl_surface_newfrac(itime, pctsrf, pctsrf_old,        &
+           evap, z0m, z0h, agesno,                                &
+           tsurf, alb_dir,alb_dif, ustar, u10m, v10m, pbl_tke)
 
 
Index: LMDZ5/branches/testing/libf/phylmd/clcdrag.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/clcdrag.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/clcdrag.F90	(revision 2298)
@@ -129,6 +129,9 @@
            pcfh(i) = zcdn(i)* fins(zri(i))
         ENDIF
-        zcr = (0.0016/(zcdn(i)*SQRT(zdu2)))*ABS(ztvd-ztsolv)**(1./3.)
-        IF(nsrf.EQ.is_oce) pcfh(i) =f_cdrag_oce* zcdn(i)*(1.0+zcr**1.25)**(1./1.25)
+        IF(iflag_gusts==0) THEN
+! cdrah sur l'ocean cf. Miller et al. (1992) - only active when gustiness parameterization is not active
+           zcr = (0.0016/(zcdn(i)*SQRT(zdu2)))*ABS(ztvd-ztsolv)**(1./3.)
+           IF(nsrf.EQ.is_oce) pcfh(i) =f_cdrag_oce* zcdn(i)*(1.0+zcr**1.25)**(1./1.25)
+        ENDIF
      ENDIF
   END DO
Index: LMDZ5/branches/testing/libf/phylmd/clesphys.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2298)
@@ -44,6 +44,10 @@
 ! Frottement au sol (Cdrag)
        Real f_cdrag_ter,f_cdrag_oce
+       REAL min_wind_speed,f_gust_wk,f_gust_bl,f_qsat_oce,f_z0qh_oce
+       REAL z0m_seaice,z0h_seaice
+       INTEGER iflag_gusts,iflag_z0_oce
+
 ! Rugoro
-       Real f_rugoro
+       Real f_rugoro,z0min
 
 !IM lev_histhf  : niveau sorties 6h
@@ -91,5 +95,7 @@
      &     , cdmmax, cdhmax, ksta, ksta_ter, f_ri_cd_min                &
      &     , fmagic, pmagic                                             &
-     &     , f_cdrag_ter,f_cdrag_oce,f_rugoro                           &
+     &     , f_cdrag_ter,f_cdrag_oce,f_rugoro,z0min                     &
+     &     , min_wind_speed,f_gust_wk,f_gust_bl,f_qsat_oce,f_z0qh_oce   &
+     &     , z0m_seaice,z0h_seaice                                      &
      &     , pasphys            , freq_outNMC, freq_calNMC              &
      &     , lonmin_ins, lonmax_ins, latmin_ins, latmax_ins             &
@@ -115,4 +121,5 @@
      &     , ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP                     &
      &     , ip_ebil_phy                                                &
+     &     , iflag_gusts ,iflag_z0_oce                                  &
      &     , ok_lic_melt,           aer_type                            &
      &     , iflag_rrtm, ok_strato,ok_hines, ok_qch4                    &
